package com.engine.organization.entity.job.dto;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.OrganizationTableOperate;
import com.engine.organization.annotation.TableTitle;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @description: TODO
 * @author:dxfeng
 * @createTime: 2022/05/30
 * @version: 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "0efea835-dfc5-11ec-a09e-00e04c680716",
        tableType = WeaTableType.NONE,
        operates = {
                @OrganizationTableOperate(index = "0", text = "编辑"),
                @OrganizationTableOperate(index = "1", text = "删除"),
                @OrganizationTableOperate(index = "2", text = "合并"),
                @OrganizationTableOperate(index = "3", text = "转移"),
                @OrganizationTableOperate(index = "4", text = "联查岗位"),
                @OrganizationTableOperate(index = "4", text = "联查人员")
        })
public class JobListDTO {
    /**
     * 主键
     */
    private Long id;

    /**
     * 编号
     */
    @TableTitle(title = "编号", dataIndex = "jobNo", key = "jobNo")
    private String jobNo;
    /**
     * 名称
     */
    @TableTitle(title = "名称", dataIndex = "jobName", key = "jobName")
    private String jobName;
    /**
     * 所属分部
     */
    @TableTitle(title = "所属分部", dataIndex = "parentComp", key = "parentComp")
    private String compName;
    /**
     * 所属部门
     */
    @TableTitle(title = "所属部门", dataIndex = "parentDept", key = "parentDept")
    private String deptName;
    /**
     * 岗位序列
     */
    @TableTitle(title = "岗位序列", dataIndex = "sequenceId", key = "sequenceId")
    private String sequenceName;
    /**
     * 等级方案
     */
    @TableTitle(title = "等级方案", dataIndex = "schemeId", key = "schemeId")
    private String schemeName;
    /**
     * 上级岗位
     */
    @TableTitle(title = "上级岗位", dataIndex = "parentJob", key = "parentJob")
    private String parentJobName;
    private Long parentJob;
    /**
     * 是否关键岗
     */
    @TableTitle(title = "是否关键岗", dataIndex = "isKey", key = "isKey")
    private String isKey;

    /**
     * 禁用标记
     */
    @TableTitle(title = "禁用标记", dataIndex = "forbiddenTag", key = "forbiddenTag")
    private Integer forbiddenTag;

    /**
     * 子节点
     */
    private List<JobListDTO> children;
}
