package com.engine.organization.entity.scheme.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "98e9c62f-cd12-11ec-a15f-00ffcbed7508",
        fields = "t.id," +
                "t.scheme_no," +
                "t.scheme_name," +
                "t.scheme_description," +
                "t.forbidden_tag," +
                "t.creator," +
                "t.delete_type," +
                "t.create_time," +
                "t.update_time",
        fromSql = "FROM jcl_org_scheme t ",
        orderby = "id desc",
        primarykey = "id",
        operates = {
                @OrganizationTableOperate(index = "0", text = "编辑"),
                @OrganizationTableOperate(index = "1", text = "删除")
        },
        tableType = WeaTableType.CHECKBOX,
        operatePopedom = @OperatePopedom(transmethod = "com.engine.organization.util.ConfigTrans.formatSourceOperates",otherpara = "column:forbidden_tag"),
        checkboxPopedom = @CheckboxPopedom(showmethod = "com.engine.organization.util.ConfigTrans.getCheckBoxPopedom",popedompara = "column:forbidden_tag")
)
public class SchemeTableVO {
    /**
     * 主键
     */
    @OrganizationTableColumn(column = "id", display = false)
    private Long id;


    /**
     * 方案编号
     */
    @OrganizationTableColumn(text = "编号", width = "25%", column = "scheme_no")
    private String schemeNo;
    /**
     * 方案名称
     */
    @OrganizationTableColumn(text = "方案名称", width = "25%", column = "scheme_name")
    private String schemeName;

    /**
     * 方案描述
     */
    @OrganizationTableColumn(text = "方案说明", width = "25%", column = "scheme_description")
    private String schemeDescription;

    /**
     * 禁用标识
     */
    @OrganizationTableColumn(text = "禁用标记", width = "25%", column = "forbidden_tag")
    private Integer forbiddenTag;
}
