package com.engine.organization.entity.staff.vo;

import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.OrganizationTableColumn;
import com.engine.organization.annotation.OrganizationTableOperate;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * @description: TODO
 * @author:dxfeng
 * @createTime: 2022/05/25
 * @version: 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@OrganizationTable(pageId = "e04abd72-dbd6-11ec-b69e-00ffcbed7508",
        fields = "t.id, t.plan_no, t.plan_name, t.plan_year, t.time_start, t.time_end, t.forbidden_tag",
        fromSql = "FROM jcl_org_staffplan t ",
        orderby = "id desc",
        primarykey = "id",
        operates = {
                @OrganizationTableOperate(index = "0", text = "编辑"),
                @OrganizationTableOperate(index = "1", text = "删除"),
                @OrganizationTableOperate(index = "2", text = "发起编制流程")
        }
)
public class StaffPlanTableVO {

    /**
     * 主键
     */
    @OrganizationTableColumn(column = "id", display = false)
    private Long id;
    /**
     * 编号
     */
    @OrganizationTableColumn(text = "编号", width = "16%", column = "plan_no")
    private String planNo;
    /**
     * 名称
     */
    @OrganizationTableColumn(text = "名称", width = "16%", column = "plan_name")
    private String planName;
    /**
     * 年度
     */
    @OrganizationTableColumn(text = "年度", width = "16%", column = "plan_year")
    private Integer planYear;
    /**
     * 时间开始
     */
    @OrganizationTableColumn(text = "时间开始", width = "16%", column = "time_start")
    private Date timeStart;
    /**
     * 时间结束
     */
    @OrganizationTableColumn(text = "时间结束", width = "16%", column = "time_end")
    private Date timeEnd;
    /**
     * 状态
     */
    @OrganizationTableColumn(text = "状态", width = "16%", column = "forbidden_tag")
    private Integer forbiddenTag;

}
