package com.engine.organization.mapper.job;

import com.engine.organization.entity.job.dto.JobListDTO;
import com.engine.organization.entity.job.po.JobPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description: TODO
 * @Date 2022/5/20
 * @Version V1.0
 **/
public interface JobMapper {

    /**
     * 根据搜索条件查询数据
     *
     * @return
     */
    List<JobListDTO> listByFilter(JobPO jobPO);

    /**
     * 展示所有列表数据
     *
     * @return
     */
    List<JobListDTO> listNoFilter();

    /**
     * 根据ID查询元素
     *
     * @param id
     * @return
     */
    JobPO getJobById(@Param("id") Long id);

    /**
     * 根据父ID查询元素
     *
     * @param pid
     * @return
     */
    List<JobPO> getJobsByPid(@Param("pid") Long pid);

    /**
     * 浏览按钮展示数据用
     *
     * @param ids
     * @return
     */
    List<Map<String, Object>> listJobsByIds(@Param("ids") Collection<Long> ids);

    /**
     * 根据编号查询数据
     *
     * @param jobNo
     * @return
     */
    List<JobPO> listByNo(@Param("jobNo") String jobNo);

    /**
     * 添加数据
     *
     * @param jobPO
     * @return
     */
    int insertIgnoreNull(JobPO jobPO);


    /**
     * 更新主表内容
     *
     * @param jobPO
     * @return
     */
    int updateBaseJob(JobPO jobPO);

    /**
     * 更新禁用标识
     *
     * @param id
     * @param forbiddenTag
     * @return
     */
    int updateForbiddenTagById(@Param("id") long id, @Param("forbiddenTag") int forbiddenTag);

    /**
     * 批量删除
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

}
